# -*- coding: utf-8 -*-
"""
Backtesting "Frei Schnauze"-System

Teil 1 von 4
Datendownload Yahoo-Finance


"""
import numpy as np
import time
from matplotlib.finance import quotes_historical_yahoo

# Timer starten für Laufzeitmessung
tic = time.clock()

# Testmodus (nur ein paar Aktienkurse herunterladen)
# true oder false
bTestmode = "false"



# Start- und Enddatum (yyyy,[m]m,[d]d)
date1 = ( 2001, 1, 1)
date2 = ( 2012, 10, 31 )
print date1
print date2


# Tickerliste einlesen
f = open('ticker.txt' , 'r+')
ticker = f.readlines()
f.close()

# Zähler für Aktien (entspricht Schleifendurchläufe)
j = len(ticker)

# Testmodus
if bTestmode == "true":
    j = 5


# Schleife über alle Aktien
for i in range(j):
    strticker_temp= ticker[i]
    if strticker_temp[-1:] == "\n":
        ticker[i] = strticker_temp[:-1]
    strName = ticker[i]
    mData = quotes_historical_yahoo(strName, date1, date2)

    # save RAW-Data
    np.save("RAW_mData_" + strName + ".npy", mData)
    # Ausgabe als Funktionskontrolle
    print "(" + str(i+1) + "/" + str(j) + ") Kursdaten von '" + strName + "' gespeichert."

# Ausgabe der Laufzeit
toc = time.clock()
print "Laufzeit: " + "%.2f" % (toc-tic) + " Sekunden"