# -*- coding: utf-8 -*-
"""
Backtesting "Frei Schnauze"-System

Teil 2 von 4
Daten prüfen, korrigieren und zusätzliche Kennzahlen berechnen.


"""

import time
# Start Zeitmessung
tic = time.clock()

import numpy as np
from pylab import *
from Utils import *


# Testmodus (nur ein Aktien auf Signale untersuchen)
# true oder false
bTestmode = "false"


# Tickerliste laden
f = open('ticker.txt' , 'r+')
ticker = f.readlines()
f.close()
j = len(ticker)
if bTestmode == "true":
    j = 5
    
    


for i in range(j):
    strticker_temp= ticker[i]
    if strticker_temp[-1:] == "\n":
        ticker[i] = strticker_temp[:-1]
    strName = ticker[i]
    print strName
    # Get Quotes
    mData = []
    mData = np.load("RAW_mData_" + strName + ".npy")
    
    size = len(mData)

    # Fehlerbereinigung bei neuen Daten
    # Open und Close hin und wieder außerhalb von high/low
    # high/low wird an Open/Close herangezogen
    # wenn Volumen an einem Tag =NULL, wird Vortageskerze wiederholt    
    for k in range(size):
        # wenn close < low dann low=close
        if mData[k,2] < mData[k,4]:
            mData[k,4] = mData[k,2]
        # wenn open > high dann high = open
        if mData[k,1] > mData[k,3]:
            mData[k,3] = mData[k,1]
        # wenn volumen 0, Daten fortschreiben
        if mData[k,5] == 0:
            mData[k,1:5] = mData[k-1,1:5]
        # wenn close > high dann high = close
        if mData[k,2] > mData[k,3]:
            mData[k,3] = mData[k,2]
        # wenn open < low dann low = open
        if mData[k,1] < mData[k,4]:
            mData[k,4] = mData[k,1]
                
                
                
    # Listen allokieren
    vDataOpen = [ ]
    vDataClose = [ ]
    vDataDate = [ ]
    vDataHigh = [ ]
    vDataLow = [ ]
    vDataVolume = [ ]
    size = len(mData)
    
      
   # geladene Daten zuweisen
    for k in range(0, size):
        vDataDate.append(mData[k][0])
        vDataOpen.append(mData[k][1])
        vDataHigh.append(mData[k][3])
        vDataLow.append(mData[k][4])
        vDataClose.append(mData[k][2])
        vDataVolume.append(mData[k][5])


    iDateSize =  len(vDataDate)    
    c1 = np.zeros(iDateSize)
    c2 = np.zeros(iDateSize)
    c3 = np.zeros(iDateSize)
    tr = np.zeros(iDateSize)
    atr = np.zeros(iDateSize)    
    idiff = np.zeros(iDateSize)

    # Schleife für ATR-Berechnung
    for k in range(0,iDateSize):

        c1[k] = vDataHigh[k] - vDataLow[k]
        c2[k] = abs(vDataHigh[k] - vDataClose[k-1])
        c3[k] = abs(vDataLow[k] - vDataClose[k-1]) 
        
    # TR berechnen (maximum nur mit 2 arrays)
    tr = np.maximum(c1, c2)
    tr = np.maximum(tr, c3)

    # ATR 10 berechnen    
    atr = moving_average(tr, 10, 'simple')
    vDataATR = atr
    
    # ATR 2 berechnen    
    atr = moving_average(tr, 2, 'simple')
    vDataATR2 = atr
    
    # lokale Hochs (2 und 15 Tage) allokieren
    vHMax2 = np.zeros(iDateSize)
    vHMax15 = np.zeros(iDateSize)
    
    # lokale Tiefs (2 und 15 Tage) allokieren
    vLMax2 = np.zeros(iDateSize)
    vLMax15 = np.zeros(iDateSize)
    
    # Lokale Hochs und Tiefs ermitteln
    for k in range(iDateSize):
        if k>2:
            vHMax2[k] = np.max(vDataHigh[k-2:k])
            vLMax2[k] = np.min(vDataLow[k-2:k])
        if k>15:
            vHMax15[k] = np.max(vDataHigh[k-15:k])
            vLMax15[k] = np.min(vDataLow[k-15:k])    
    
    # SMA100 + SMA20 berechnen    
    vClose = np.zeros(len(vDataClose))
    for k in range(len(vDataClose)) :   
        vClose[k] = vDataClose[k]
   
    sma100 = moving_average(vClose, 100, 'simple')
    vDataSMA100 = sma100
    
    sma20 = moving_average(vClose, 20, 'simple')
    vDataSMA20 = sma20

    # Matrix zusammenbauen
    # zusätzliche Indikatoren werden an Kursdaten angehängt (neue Spalte)
    mData = np.column_stack((mData , vDataATR))
    mData = np.column_stack((mData , vDataATR2))
    mData = np.column_stack((mData , vDataSMA100))
    mData = np.column_stack((mData , vDataSMA20))
    mData = np.column_stack((mData , vHMax2))
    mData = np.column_stack((mData , vLMax2))
    mData = np.column_stack((mData , vHMax15))
    mData = np.column_stack((mData , vLMax15))

    # Daten speichern unter neuem Namen
    # Rohdaten bleiben also erhalten
    np.save("mData_" + strName + ".npy", mData)
    
#Laufzeit ausgeben
toc = time.clock()
print "Laufzeit: " + "%.2f" % (toc-tic) + " Sekunden" 
                    