# -*- coding: utf-8 -*-
"""
Backtesting "Frei Schnauze"-System

Teil 3 von 4
Signalgenerierung


"""
import time
# Start Zeitmessung
tic = time.clock()

import numpy as np
from pylab import *
from Utils import *


# Testmodus (nur ein Aktien auf Signale untersuchen)
# true oder false
bTestmode = "false"

# Tickerliste laden
f = open('ticker.txt' , 'r+')
ticker = f.readlines()
f.close()
j = len(ticker)
if bTestmode == "true":
    j = 5

# Eindeutigen Datumsvektor bauen für alle möglichen Signaltage
for i in range(j):
    strticker_temp= ticker[i]
    if strticker_temp[-1:] == "\n":
        ticker[i] = strticker_temp[:-1]
    strName = ticker[i]
    # Get Quotes
    mData = []
    mData = np.load("mData_" + strName + ".npy")    
    
    # Create empty lists, quick and dirty
    vDataDate = [ ]
    size = len(mData)
    
   
    # Daten zusammenfügen
    for k in range(1, size):
        vDataDate.append(mData[k][0])
    
    # Zusammensetzen zu einem Vektor
    if i > 0 :
        vUniqueDate = np.union1d(vUniqueDate,vDataDate)
    else:
        vUniqueDate = np.union1d(vDataDate,vDataDate)


print "Anzahl Tage: " + str(len(vUniqueDate))

print "Date-Vektor aufgebaut."


# Ergebnismatrix mit Scoring allokieren
mScoringL = zeros((len(vUniqueDate),j))
mScoringS = zeros((len(vUniqueDate),j))


# Schleife über alle Unternehmen
for i in range(j):
    strticker_temp= ticker[i]
    ticker[i] = strticker_temp[:]
    strName = ticker[i]
    print "Ticker: " + str(strName)
    # Kursdaten laden
    mData = []
    mData = np.load("mData_" + strName + ".npy")
    # Listen allokieren
    vDataOpen = [ ]
    vDataClose = [ ]
    vDataDate = [ ]
    vDataHigh = [ ]
    vDataLow = [ ]
    vDataVolume = [ ]
    vDataATR =  []
    vDataATR2 =  []
    vDataSMA100 =  []
    vDataSMA20 =  []
    vHMax2 =  []
    vLMax2 =  []
    vHMax15 = []
    vLMax15 = []
    
    size = len(mData)
    
      
    # geladene Daten zuweisen
    for k in range(1, size):
        vDataDate.append(mData[k][0])
        vDataOpen.append(mData[k][1])
        vDataHigh.append(mData[k][3])
        vDataLow.append(mData[k][4])
        vDataClose.append(mData[k][2])
        vDataVolume.append(mData[k][5])
        vDataATR.append(mData[k][6])
        vDataATR2.append(mData[k][7])
        vDataSMA100.append(mData[k][8])
        vDataSMA20.append(mData[k][9])
        vHMax2.append(mData[k][10])
        vLMax2.append(mData[k][11])
        vHMax15.append(mData[k][12])
        vLMax15.append(mData[k][13])                                                
        
    iDateSize =  len(vDataDate)    
    
 
    # tägliches Scoring pro Aktie durchführen
    # Wenn Mindestvoraussetzungen erfüllt, erfolgt weiteres Scoring
    
    # Vektoren allokieren
    vScoreL = np.zeros(iDateSize)
    vScoreS = np.zeros(iDateSize)
    
  
   
    for k in range(1,iDateSize):
        # LONG-Scoring
        # ATR2 niedriger als ATR10
        if vDataATR2[k] < vDataATR[k]:
            # bullishe Kerze
            if vDataClose[k] > vDataOpen[k]:
                # günstigerer Einstieg
                if vDataHigh[k] < vDataHigh[k-1]:
                    # Range < 0,8 ATR10
                    if (vDataHigh[k] - vDataLow[k]) < 0.8*vDataATR[k]:
                        # Close in oberer Hälfte
                        if vDataClose[k] >= (vDataHigh[k] - (vDataHigh[k] - vDataLow[k])/2):
                            # Das waren die Mindestvoraussetzungen.
                            # mindestens 3 Tage Korrektur
                            if vDataClose[k] < vDataHigh[k-1] and vDataClose[k] < vDataHigh[k-2] and vDataClose[k] < vDataHigh[k-3]:
                                vScoreL[k] = vScoreL[k] +1
                                # aktuelle Vola kleiner als am Vortag    
                                if abs(vDataATR[k]) < abs(vDataATR[k-1]):
                                    vScoreL[k] = vScoreL[k] +1
                                # naher Trigger
                                if (vDataHigh[k] - vDataClose[k]) < ((0.3*vDataHigh[k]) - vDataLow[k]):
                                    vScoreL[k] = vScoreL[k] +1
                                # fallende Lows, Korrektur im Gange
                                if vDataLow[k] < vDataLow[k-1] < vDataLow[k-2]:
                                    vScoreL[k] = vScoreL[k] +1
                                # besonders kleine Kerze
                                if vDataHigh[k] - vDataLow[k] < 0.6*vDataATR[k]:
                                    vScoreL[k] = vScoreL[k] +1
                                # Close am Tageshoch
                                if vDataClose[k] == vDataHigh[k]:
                                    vScoreL[k] = vScoreL[k] +1
                                # Abzug für geringes Volumen
                                if vDataVolume[k] * vDataClose[k] < 2000000:
                                    vScoreL[k] = vScoreL[k] -1
                                # Abzug für geringes Volumen
                                if vDataVolume[k] * vDataClose[k] < 1000000:
                                    vScoreL[k] = vScoreL[k] -1
                                # kein neues Tief
                                if vLMax2[k] > vLMax15[k]:
                                    vScoreL[k] = vScoreL[k] +1
                                # neues Tief (Punktabzug)
                                if vLMax2[k] <= vLMax15[k]:
                                    vScoreS[k] = vScoreS[k] -1                                         
                                # Punkte für Korrekturausmaß
                                if vHMax15[k] - vDataHigh[k] > 0.4 * vDataATR[k]:
                                    vScoreL[k] = vScoreL[k] +1
                                if vHMax15[k] - vDataHigh[k] > 0.6 * vDataATR[k]:
                                    vScoreL[k] = vScoreL[k] +1
                                if vHMax15[k] - vDataHigh[k] > 0.8 * vDataATR[k]:
                                    vScoreL[k] = vScoreL[k] +1
                                if vDataSMA100[k] < vDataSMA20[k]:
                                    vScoreL[k] = vScoreL[k] +1
                                # steigender SMA20
                                if vDataSMA20[k] >= vDataSMA20[k-1]:
                                    vScoreL[k] = vScoreL[k] +1

        # SHORT-Scoring
        # ATR2 niedriger als ATR10 
        if vDataATR2[k] < vDataATR[k]:
            # bearishe Kerze
            if vDataClose[k] < vDataOpen[k]:
                # günstigerer Einstieg
                if vDataLow[k] > vDataLow[k-1]:
                    # Range < 0,8 ATR10
                    if (vDataHigh[k] - vDataLow[k]) < 0.8*vDataATR[k]:
                        # Close in unterer Hälfte
                        if vDataClose[k] <= (vDataLow[k] + (vDataHigh[k] - vDataLow[k])/2):
                            # Das waren die Mindestvoraussetzungen.                                
                            # mindestens 3 Tage Korrektur  
                            if vDataClose[k] > vDataLow[k-1] and vDataClose[k] > vDataLow[k-2] and vDataClose[k] > vDataLow[k-3]:
                                vScoreS[k] = vScoreS[k] +1
                                # aktuelle Vola kleiner als am Vortag    
                                if abs(vDataATR[k]) < abs(vDataATR[k-1]):
                                    vScoreS[k] = vScoreS[k] +1
                                # naher Trigger
                                if (vDataLow[k] - vDataClose[k]) < ((0.3*vDataHigh[k]) - vDataLow[k]):
                                    vScoreS[k] = vScoreS[k] +1
                                # steigende Highs, Korrektur im Gange
                                if vDataHigh[k] > vDataHigh[k-1] > vDataLow[k-2]:
                                    vScoreS[k] = vScoreS[k] +1
                                # besonders kleine Kerze
                                if vDataHigh[k] - vDataLow[k] < 0.6*vDataATR[k]:
                                    vScoreS[k] = vScoreS[k] +1
                                # Close am Tagestief
                                if vDataClose[k] == vDataLow[k]:
                                    vScoreS[k] = vScoreS[k] +1
                                # Abzug für geringes Volumen     
                                if vDataVolume[k] * vDataClose[k] < 2000000:
                                    vScoreS[k] = vScoreS[k] -1
                                # Abzug für geringes Volumen     
                                if vDataVolume[k] * vDataClose[k] < 1000000:
                                    vScoreS[k] = vScoreS[k] -1
                                # kein neues Hoch
                                if vHMax2[k] < vHMax15[k]:
                                    vScoreS[k] = vScoreS[k] +1
                                # neues Hoch (Punktabzug)
                                if vHMax2[k] >= vHMax15[k]:
                                    vScoreS[k] = vScoreS[k] -1                                
                                # Punkte für Korrekturausmaß
                                if vDataLow[k] - vLMax15[k] > 0.4 * vDataATR[k]:
                                    vScoreS[k] = vScoreS[k] +1
                                if vDataLow[k] - vLMax15[k] > 0.6 * vDataATR[k]:
                                    vScoreS[k] = vScoreS[k] +1
                                if vDataLow[k] - vLMax15[k] > 0.8 * vDataATR[k]:
                                    vScoreS[k] = vScoreS[k] +1                     
                                if vDataSMA100[k] > vDataSMA20[k]:
                                    vScoreS[k] = vScoreS[k] +1  
                                #  fallender SMA20
                                if vDataSMA20[k] <= vDataSMA20[k-1]:
                                    vScoreS[k] = vScoreS[k] +5 

                            
    # Datenmatching
    # Unternehmen haben unterschiedliche Zeitreihen (Kursverfügbarkeit)
    # Scoringergebnisse aller Unternehmen eines Datums in die selbe Zeile bringen
    for k in range(len(vUniqueDate)):
        itempL = vScoreL[(vDataDate==vUniqueDate[k])]
        itempS = vScoreS[(vDataDate==vUniqueDate[k])]
       
        if itempL > 0:
            if len(itempL) > 0:        
                mScoringL[k,i] = itempL
        if itempS > 0:            
            if len(itempS) > 0:        
                mScoringS[k,i] = itempS
    # Ausgabe zur Kontrolle
    print str(i+1) + " von " + str(j) + " Aktien untersucht."        
    # Ende der Schleife, nächstes Unternehmen


# Listen allokieren für Signale (Long und Short)
# Jeweils Datum, Unternehmen und Punktwert gespeichert
vMaxL = mScoringL.max(axis=1)
vSignalDateL = []
vSignalUntL = []
vSignalPunL = []

vMaxS = mScoringS.max(axis=1)
vSignalDateS = []
vSignalUntS = []
vSignalPunS = []

# Maximalwert pro Tag ermitteln
# Falls Maximal-Wert mehrfach: Unternehmen zufällig wählen
for k in range(1,len(vUniqueDate)):
    l = mScoringL[k,:]
    m = max(l)
    if m > 0 :
        vIndex = [o for o, p in enumerate(l) if p == m]      
        # zufällig gewähltes Unternehmen mit Maximalwert 
        b = len(vIndex)  
        iRnd = np.random.randint(0, b)       
        iUnt = vIndex[iRnd-1]
        strUnt = ticker[iUnt]
        vSignalDateL.append(vUniqueDate[k])
        vSignalUntL.append(strUnt)
        vSignalPunL.append(m)
 
    l = mScoringS[k,:]
    m = max(l)
    if m > 0 :
        vIndex = [o for o, p in enumerate(l) if p == m]      
        # zufällig gewähltes Unternehmen mit Maximalwert        
        b = len(vIndex) 
        iRnd = np.random.randint(0, b) 
        iUnt = vIndex[iRnd-1]
        strUnt = ticker[iUnt]
        vSignalDateS.append(vUniqueDate[k])
        vSignalUntS.append(strUnt)
        vSignalPunS.append(m)


# Signale speichern
np.save("mSignals_Long.npy", vSignalUntL)
np.save("mSignalDates_Long.npy", vSignalDateL)
np.save("mSignalPunkte_Long.npy", vSignalPunL)
print "Long-Signale gespeichert."

np.save("mSignals_Short.npy", vSignalUntS)
np.save("mSignalDates_Short.npy", vSignalDateS)
np.save("mSignalPunkte_Short.npy", vSignalPunS)
print "Short-Signale gespeichert."

   
 #Laufzeit ausgeben
toc = time.clock()
print "Laufzeit: " + "%.2f" % (toc-tic) + " Sekunden" 