# -*- coding: utf-8 -*-
"""
Backtesting "Frei Schnauze"-System

Teil 4 von 4
Backtest und Statistik


"""
import time
# Start Zeitmessung
tic = time.clock()


import numpy as np
from pylab import *
from matplotlib import *
from matplotlib.dates import date2num
from Utils import *
import operator
from matplotlib.dates import  DateFormatter, WeekdayLocator, HourLocator, \
             DayLocator, MONDAY
from matplotlib.finance import quotes_historical_yahoo, candlestick,\
             plot_day_summary, candlestick2 
import matplotlib.dates as mdates
from matplotlib.backends.backend_qt4agg import FigureCanvasQTAgg as FigureCanvas



# Testmodus (nur ein paar Trades auswerten)
bTestmode = "false"

# Was soll ausgewertet werden?
# Long und oder Shorttrades
# true oder false
bLong = "true"
bShort = "true"

# Chart zu jedem Trade speichern
# dauert 0.5-1 Sekunde extra pro Trade!
bSaveTrade = "false"

# Chart zu jedem Trade anzeigen
# Chart-Fenster muss immer weggeklickt werden.
# Abschalten für schnellen Durchlauf
bShowTrade = "false"

# Charts zur Zusammenfassung zeigen. (GuV, Depotvalue)
bShowFig = "true"

# Charts zur Zusammenfassung speichern. (GuV, Depotvalue)
bSaveFig = "false"

# Clean-Mode: ohne Spread, Gebühren, Slippage
bCleanMode = "false"


# Diff über High zum Einstieg in EUR (2 Cent)
iDiffEntry = 0.02
# 0,1% Spread (halben Spread jeweils bei Ein- und Ausstieg) 0.001
iSpread = 0.001
# Ziel CRV (3)
cCRV = 2
# StopLoss = 0.6*ATR
cSL = 1.0
# TakeProfit = cCRV * cSL
cTP = cSL * cCRV
# Startkapital
iDepotValue = 10000
iInit = iDepotValue
# 1% Risiko pro Trade
iRisk = 0.01
# 0.1 % Slippage (0.001)
iSlippage = 0.001
# Am Ende des fünften Tages Position schließen
iTimeStop = 5
# Fixe Gebühr in EUR
iFixGeb = 0
# var. Gebühr dezimal 0.001(0.00085 inkl. Rabatt) [ETX-Capital & BrokerDeal]
iVarGeb = 0.00085
# Minimum-Score
iMinScore = 7


if bCleanMode == "true":
    iSpread = 0
    iSlippage = 0
    iFixGeb = 0
    iVarGeb = 0



# LongSignale laden
vSignalUntL = []
vSignalDateL = []
vSignalPoiL =[]
vSignalUntL = np.load("mSignals_Long.npy")
vSignalDateL = np.load("mSignalDates_Long.npy")
vSignalPoiL = np.load("mSignalPunkte_Long.npy")

# Fehlerabfrage, wenn Date und Unternehmen nicht zusammenpassen
if len(vSignalDateL) <> len(vSignalUntL):
        print "Fehler: Vektoren der Long-Signale nicht gleich lang!"

# ShortSignale laden
vSignalUntS = []
vSignalDateS = []
vSignalPoiS = []
vSignalUntS = np.load("mSignals_Short.npy")
vSignalDateS = np.load("mSignalDates_Short.npy")
vSignalPoiS = np.load("mSignalPunkte_Short.npy")

# Fehlerabfrage, wenn Date und Unternehmen nicht zusammenpassen
if len(vSignalDateS) <> len(vSignalUntS):
        print "Fehler: Vektoren der Short-Signale nicht gleich lang!"
        

# Matrix aufbauen: Long und Short-Signale zusammen bringen und nach Datum sortieren
# Also Reihenfolge der Tradeausführung festlegen
l = []
for i in range (len(vSignalDateL)):
    l.append({'date': vSignalDateL[i],'ticker': vSignalUntL[i], 'richtung': "Long", 'score': vSignalPoiL[i] })

for i in range (len(vSignalDateS)):
    l.append({'date': vSignalDateS[i],'ticker': vSignalUntS[i], 'richtung': "Short", 'score': vSignalPoiS[i] })

l.sort(key=lambda x: x['date'])


   
# eindeutige Tradedaten (Depotvalue-Vektoren)        
vDate = []
for i in range(len(l)):
    b = l[i]
    iDate = b['date']
    vDate.append(iDate)

vUniqueDate = np.union1d(vDate,vDate)

# Variablen für Testmodus ändern
j = len(l)
if bTestmode == "true": 
    j = 600
    vUniqueDate = vUniqueDate[0:j]
    vDepotValue = zeros(len(vDate))
    vDate = vDate[0:j]
 
# Vektoren für stetiges tägliches Erfassen  
vGuV = zeros(j)
vDepotValue = zeros(j)
vDepotValue[0] = iInit
vGeb = []
vGuVLong = []
vGuVShort = []
vR = []
vRLong = []
vRShort = []
vK = []
vKL = []
vKS = []

# Zähler eröffnete Trades
opened = 0

# Dictionary für alle Kursdaten und zusätzliche Indikatoren
dData = {}

# Tickerliste laden
f = open('ticker.txt' , 'r+')
ticker = f.readlines()
f.close()
m = len(ticker)

# Kursdaten laden
print "Kursdaten laden..."
for i in range(m):
    strticker_temp= ticker[i]
    if strticker_temp[-1:] == "\n":
        ticker[i] = strticker_temp[:-1]
    strName = ticker[i]


    mData = []
    mData = np.load("mData_" + strName + ".npy")    
    
    # Listen allokieren
    vDataOpen = [ ]
    vDataClose = [ ]
    vDataDate = [ ]
    vDataHigh = [ ]
    vDataLow = [ ]
    vDataVolume = [ ]
    vDataATR =  []
    vDataATR2 =  []
    vDataSMA100 =  []
    vDataSMA20 =  []
    vHMax2 =  []
    vLMax2 =  []
    vHMax15 = []
    vLMax15 = []
  
    size = len(mData)
   
      
    # geladene Daten zuweisen
    for k in range(0, size):
        vDataDate.append(mData[k][0])
        vDataOpen.append(mData[k][1])
        vDataHigh.append(mData[k][3])
        vDataLow.append(mData[k][4])
        vDataClose.append(mData[k][2])
        vDataVolume.append(mData[k][5])
        vDataATR.append(mData[k][6])
        vDataATR2.append(mData[k][7])
        vDataSMA100.append(mData[k][8])
        vDataSMA20.append(mData[k][9])
        vHMax2.append(mData[k][10])
        vLMax2.append(mData[k][11])
        vHMax15.append(mData[k][12])
        vLMax15.append(mData[k][13]) 

    # Spalte einer Matrix einem Liste im Dictionary zuordnen
    dData["mData" + str(strName) + "_Date"] = vDataDate
    dData["mData" + str(strName) + "_Open"] = vDataOpen
    dData["mData" + str(strName) + "_High"] = vDataHigh    
    dData["mData" + str(strName) + "_Low"] = vDataLow
    dData["mData" + str(strName) + "_Close"] = vDataClose
    dData["mData" + str(strName) + "_Volume"] = vDataVolume
    dData["mData" + str(strName) + "_ATR"] = vDataATR
    dData["mData" + str(strName) + "_ATR2"] = vDataATR2
    dData["mData" + str(strName) + "_SMA100"] = vDataSMA100
    dData["mData" + str(strName) + "_SMA20"] = vDataSMA20
    dData["mData" + str(strName) + "_HMax2"] = vHMax2
    dData["mData" + str(strName) + "_LMax2"] = vLMax2
    dData["mData" + str(strName) + "_HMax15"] = vHMax15
    dData["mData" + str(strName) + "_LMax15"] = vLMax15
print "... Daten geladen."



###### Backtesting ######
# Schleife über alle Trades (letzte Trade werden weggelassen, weil keine Kursdaten)
#for i in range(j-iTimeStop-iTimeStop-2):
for i in range(j):
    b = l[i]
    iScore = b['score']
    # Signal nicht traden, wenn Score unter Minimumscore    
    if iScore < iMinScore:
        continue
    
    # Tradedaten: Datum, Unternehmen, Handelsrichtung
    iDate = b['date']
    iUnt = b['ticker']
    iDir = b['richtung']


    # überspringen, falls nur long bzw. short ausgewertet werden soll.
    if iDir == "Long" and bLong == "false":
        continue
    if iDir == "Short" and bShort == "false":
        continue

 
    # Daten verlinken
    vDataOpen = dData["mData" + str(iUnt) + "_Open"]
    vDataClose = dData["mData" + str(iUnt) + "_Close"]
    vDataDate = dData["mData" + str(iUnt) + "_Date"]
    vDataHigh = dData["mData" + str(iUnt) + "_High"]
    vDataLow = dData["mData" + str(iUnt) + "_Low"]
    vDataVolume = dData["mData" + str(iUnt) + "_Volume"]
    vDataATR = dData["mData" + str(iUnt) + "_ATR"]
    vDataATR2 = dData["mData" + str(iUnt) + "_ATR2"]
    vDataSMA100 = dData["mData" + str(iUnt) + "_SMA100"]
    vDataSMA20 = dData["mData" + str(iUnt) + "_SMA20"]
    vHMax2 = dData["mData" + str(iUnt) + "_HMax2"]
    vLMax2 = dData["mData" + str(iUnt) + "_LMax2"]
    vHMax15 = dData["mData" + str(iUnt) + "_HMax15"]
    vLMax15 = dData["mData" + str(iUnt) + "_LMax15"]



    # Tradedatum in den Kurszeitreihen suchen
    vIndex = [o for o, p in enumerate(vDataDate) if p == iDate]
    if len(vIndex) <> 1:
        print "Fehler : 'vIndex' nicht '1'. iDate nicht gefunden."
        continue
    
    iIndex = vIndex[0]
    
    # Trade überspringen, wenn keine ausreichenden Kursdaten vorhanden (am Ende)
    if iIndex > len(vDataDate)-iTimeStop-20:
        continue

    # Backtesting ab 2002, Yahoo-Daten in 2001 komisch (Splits falsch?)
    year = time.strftime(str(num2date(vDataDate[iIndex+1])))[0:4]
    if year == "2001":
        continue
    
    
    # Ein- und Ausstiege bestimmen
    if iDir == "Long":
        iStopbuy = vDataHigh[iIndex] + iDiffEntry + ((iSpread * vDataHigh[iIndex])/2) 
        iSL = iStopbuy - cSL * vDataATR[iIndex] + ((iSpread * iStopbuy)/2)
        iTP = iStopbuy + cTP * vDataATR[iIndex] + ((iSpread * iStopbuy)/2)
        iAnz = floor(abs(iDepotValue * iRisk / (iStopbuy - iSL)))
    elif iDir == "Short":
        iStopsell = vDataLow[iIndex] - iDiffEntry - ((iSpread * vDataLow[iIndex])/2) 
        iSL = iStopsell + cSL * vDataATR[iIndex] - ((iSpread * iStopsell)/2)
        iTP = iStopsell - cTP * vDataATR[iIndex] - ((iSpread * iStopsell)/2)
        iAnz = floor(abs(iDepotValue * iRisk / (iStopsell - iSL)))
    else:
        print "Fehler : 'iDir' nicht korrekt angegeben"
        break
        

 
    # Variablen für Tradeverlauf
    bSL = 0
    bTP = 0
    iGuV = 0
    iGuVallin = 0
    iClose = 0
    iGeb = 0
    iR = iDepotValue * iRisk
    iVol = 0
    iDiff = 0
    bOpen = "false"

    
    # Trade überspringen, wenn Anzahl Aktien <=0
    if iAnz <= 0:
        continue
    
    ###### Long-Trade eröffnet?
    if  iDir == "Long" and vDataHigh[iIndex+1] >= iStopbuy:
        iOpen = iStopbuy
        opened = opened +1
        bOpen = "true"

        # Trade mit Eröffnung gestartet? (Gap) --> SL und TP neu berechnen       
        if vDataOpen[iIndex+1] >= iStopbuy:
            iOpen = vDataOpen[iIndex+1] + (iSlippage * vDataOpen[iIndex+1])
            iDiff = iOpen - iStopbuy
            iSL = iSL + iDiff
            iTP = iTP + iDiff
 
        for k in range(1,iTimeStop+1):
            if vDataOpen[iIndex+k] <= iSL:
                iClose = vDataOpen[iIndex+k] - (iSlippage * vDataOpen[iIndex+k])
                break
            if vDataOpen[iIndex+k] >= iTP:
                iClose = vDataOpen[iIndex+k] - (iSlippage * vDataOpen[iIndex+k])
                break                
            if vDataLow[iIndex+k] <= iSL:
                iClose = iSL
                break
            if vDataHigh[iIndex+k] >= iTP:
                iClose = iTP
                break
            iClose = vDataClose[iIndex+k]
            vK.append(k)
            vKL.append(k)
            
        # GuV-Berechnung
        iGuV = iAnz * (iClose - iOpen)
        #Gebührenberechnung
        iGeb = (2 * iFixGeb) + (iVarGeb * iOpen * iAnz) + (iVarGeb * iClose * iAnz)
        iGuV = iGuV - iGeb
                
     
    ###### Short-Trade eröffnet?
    if iDir == "Short" and vDataLow[iIndex+1] <= iStopsell:
        iOpen = iStopsell
        opened = opened +1
        bOpen = "true"

        # Trade mit Eröffnung gestartet? (Gap) --> SL und TP neu berechnen       
        if vDataOpen[iIndex+1] <= iStopsell:
            iOpen = vDataOpen[iIndex+1] - (iSlippage * vDataOpen[iIndex+1])
            iDiff = iOpen - iStopsell
            iSL = iSL + iDiff
            iTP = iTP + iDiff

        for k in range(1,iTimeStop+1):
            if vDataOpen[iIndex+k] >= iSL:
                iClose = vDataOpen[iIndex+k] + (iSlippage * vDataOpen[iIndex+k])
                break
            if vDataOpen[iIndex+k] <= iTP:
                iClose = vDataOpen[iIndex+k] + (iSlippage * vDataOpen[iIndex+k])
                break                
            if vDataHigh[iIndex+k] >= iSL:
                iClose = iSL
                break
            if vDataLow[iIndex+k] <= iTP:
                iClose = iTP
                break
            iClose = vDataClose[iIndex+k]
            vK.append(k)
            vKS.append(k)
        
        # GuV-Berechnung    
        iGuV = iAnz * (iOpen - iClose)
        #Gebührenberechnung
        iGeb = (2 * iFixGeb) + (iVarGeb * iOpen * iAnz) + (iVarGeb * iClose * iAnz)
        iGuV = iGuV - iGeb


    # GuV und Depotvalue berechnen + Ausgabe des Trades        
    if bOpen == "true":
        vGuV[i+k] = vGuV[i+k] + iGuV         
        vDepotValue[i] = iInit + sum(vGuV[0:i+1])        
        iDepotValue = vDepotValue[i]
        print str(iDir) + "_" + str(i+1) + " " + str(iUnt) + ": " + time.strftime(str(num2date(vDataDate[iIndex+1])))[0:10] + " ; Anz: " + "%.0f" %iAnz  + " ; Open: " + "%.2f" % iOpen + " ; Close: " + "%.2f" % iClose + " ; GuV: " + "%.2f" % iGuV  + " ; Geb: " + "%.2f" % iGeb + " ; Depot: " + "%.0f" % iDepotValue          
        if iDir == "Long":            
            vGuVLong.append(iGuV)
        elif iDir == "Short":
            vGuVShort.append(iGuV)
 
        
        iR = iGuV / iR
        vR.append(iR)  
    
    if iDir == "Long" and bOpen == "true":    
        vRLong.append(iR)
    if iDir == "Short" and bOpen == "true":
        vRShort.append(iR)   
    
    
    if vDepotValue[i] < 0:
        print "Pleite!"
        break
    


    # Candlestick-Graph speichern oder anzeigen
    if (bShowTrade == "true" or bSaveTrade == "true") and iIndex > 45 and iGuV <> 0:
        mData = vDataDate
        mData = np.column_stack((mData , vDataOpen))
        mData = np.column_stack((mData , vDataClose))
        mData = np.column_stack((mData , vDataHigh))
        mData = np.column_stack((mData , vDataLow))
        mData = mData[iIndex-40:iIndex+k+4,:]  
        

        mondays = WeekdayLocator(MONDAY)        # major ticks on the mondays
        alldays    = DayLocator()              # minor ticks on the days
        weekFormatter = DateFormatter('%b %d')  # Eg, Jan 12
        dayFormatter = DateFormatter('%d')      # Eg, 12
        fig = pyplot.figure()
        
        canvas = FigureCanvas(fig)        

        fig.subplots_adjust(bottom=0.2)
        ax = fig.add_subplot(111)
        ax.xaxis.set_major_locator(mondays)
        ax.xaxis.set_minor_locator(alldays)
        ax.xaxis.set_major_formatter(weekFormatter)
        

        plot(mData[:,0], vDataSMA20[iIndex-40:iIndex+k+4])   
        plot(mData[:,0], vDataSMA100[iIndex-40:iIndex+k+4])   
        candlestick(ax, mData, width=0.6, colorup='g', colordown='r')
        # Punkt Open
        x = mData[41,0]
        y = iOpen
        plot(x, y, 'wo') 
        # Punkt TakeProfit
        xx = mData[41,0]
        yy = iTP
        plot(xx, yy, 'go')
        # Punkt Stoploss
        xxx = mData[41,0]
        yyy = iSL
        plot(xxx, yyy, 'ro')  
        # Punkt Close        
        xxxx = mData[41+k-1,0]
        yyyy = iClose
        plot(xxxx, yyyy, 'ko') 

        title(str(iDir) + " " + time.strftime(str(num2date(vDataDate[iIndex+1])))[0:10] + " " + str(iUnt) + " " + "%.2f" %iR + "R" + " " + "%.2f" %iGuV + "EUR" + " (inkl. " + "%.2f" %iGeb + "EUR Geb.)" + " Score: " + "%.0f" %iScore )
        ax.xaxis_date()
        ax.autoscale_view()
        pyplot.setp( gca().get_xticklabels(), rotation=45, horizontalalignment='right')

        grid()
        filename = str(iDir) + "_" + time.strftime(str(num2date(vDataDate[iIndex+1])))[0:10] + "_" + str(iUnt) + ".png"

        if bSaveTrade == "true":
            savefig(filename,dpi=150)        

        if bShowTrade == "true":
            show()
        
        canvas.close()        
        fig.clear()        

# Depotvalue stetig machen. (Nullen am Anfang füllen mit vorigem Wert)
for i in range(len(vDepotValue)):
    if i > 0 and vDepotValue[i] == 0:
        vDepotValue[i] = vDepotValue[i-1]




######### Statistik gesamt       
vGewinne = []
vVerluste = []
# durchschn. Gewinn
vGewinne = remove_negatives(vGuV)
iMeanGewinn = np.mean(vGewinne)
# durchschn. Verlust
vVerluste = remove_positives(vGuV)
iMeanVerlust = np.mean(vVerluste)
# Anzahl Gewinner
iAnzGew = len(vGewinne)
# Anzahl Verlierer
iAnzVer = len(vVerluste)
# Profit-Faktor
iPF = (iMeanGewinn * iAnzGew) / (iMeanVerlust * iAnzVer * -1)

######### Statistik long
vGewinneL = []
vVerlusteL = []
# durchschn. Gewinn
vGewinneL = remove_negatives(vGuVLong)
iMeanGewinnL = np.mean(vGewinneL)
# durchschn. Verlust
vVerlusteL = remove_positives(vGuVLong)
iMeanVerlustL = np.mean(vVerlusteL)
# Anzahl Gewinner
iAnzGewL = len(vGewinneL)
# Anzahl Verlierer
iAnzVerL = len(vVerlusteL)
# Profit-Faktor
iPFL = (iMeanGewinnL * iAnzGewL) / (iMeanVerlustL * iAnzVerL * -1)

######### Statistik short
vGewinneS = []
vVerlusteS = []
# durchschn. Gewinn
vGewinneS = remove_negatives(vGuVShort)
iMeanGewinnS = np.mean(vGewinneS)
# durchschn. Verlust
vVerlusteS = remove_positives(vGuVShort)
iMeanVerlustS = np.mean(vVerlusteS)
# Anzahl Gewinner
iAnzGewS = len(vGewinneS)
# Anzahl Verlierer
iAnzVerS = len(vVerlusteS)
# Profit-Faktor
iPFS = (iMeanGewinnS * iAnzGewS) / (iMeanVerlustS * iAnzVerS * -1)





     
####### Ergebnisse:
print "--------------------------------------------" 
print "Anzahl Signale/Trades:"       
print "Gesamt: " + str(j)
print "Open: " + str(opened)
print "Cancel: " + str(j - opened)
print "--------------------------------------------"
print "Gewinner: " + "%.0f" % iAnzGew
print "Verlierer: " + "%.0f" % iAnzVer
print "--------------------------------------------"
# Trefferquote gesamt, long, short
iTQ = float(iAnzGew) / float(iAnzVer + iAnzGew)
print "Trefferquote: " + "%.2f" % iTQ
if bLong == "true":
    iTQL = float(iAnzGewL) / float(iAnzVerL + iAnzGewL)
    print "Trefferquote Long: " + "%.2f" % iTQL
if bShort == "true":
    iTQS = float(iAnzGewS) / float(iAnzVerS + iAnzGewS)
    print "Trefferquote Short: " + "%.2f" % iTQS
print "--------------------------------------------"
print "Durchschnittlicher Gewinn: " + "%.2f" % iMeanGewinn
print "Durchschnittlicher Verlust: " + "%.2f" % iMeanVerlust
print "--------------------------------------------"
print "Profit-Faktor: " + "%.2f" % iPF
print "Profit-Faktor Long: " + "%.2f" % iPFL
print "Profit-Faktor Short: " + "%.2f" % iPFS
print "--------------------------------------------"
print "Depotvalue: " + "%.0f" % iDepotValue
print "Max. Gewinn: " + "%.2f" % max(vGuV)
print "Max. Verlust: " + "%.2f" % min(vGuV)
print "--------------------------------------------"
print "Durchschnittlicher Gewinn: " + "%.2f" % numpy.mean(vGuV)
print "Durchschnittlicher Gewinn (Median): " + "%.2f" % numpy.median(vGuV)
print "--------------------------------------------"
print "Summe Long Geschaefte: " + "%.2f" % sum(vGuVLong)
print "Summe Short Geschaefte: " + "%.2f" % sum(vGuVShort)
print "--------------------------------------------"
if bLong == "true":
    print "Max. Long Gewinn: " + "%.2f" % max(vGuVLong)
    print "Max. Long Verlust: " + "%.2f" % min(vGuVLong)
if bShort == "true":
    print "Max. Short Gewinn: " + "%.2f" % max(vGuVShort)
    print "Max. Short Verlust: " + "%.2f" % min(vGuVShort)
print "--------------------------------------------"
if bLong == "true":
    print "Durchschn. Long Ertrag: " + "%.2f" % numpy.mean(vGuVLong)
if bShort == "true":
    print "Durchschn. Short Ertrag: " + "%.2f" % numpy.mean(vGuVShort)
print "--------------------------------------------"
print "Max. R: "+ "%.2f" % max(vR)
print "Min. R: "+ "%.2f" % min(vR)
print "Mean R: " + "%.2f" % numpy.mean(vR)
print "--------------------------------------------"
if bLong == "true":
    print "Max. Long R: "+ "%.2f" % max(vRLong)
    print "Min. Long R: "+ "%.2f" % min(vRLong)
    print "Mean Long R: " + "%.2f" % numpy.mean(vRLong)
print "--------------------------------------------"
if bShort == "true":
    print "Max. Short R: "+ "%.2f" % max(vRShort)
    print "Min. Short R: "+ "%.2f" % min(vRShort)
    print "Mean Short R: " + "%.2f" % numpy.mean(vRShort)
print "--------------------------------------------"

# Vorbereitung Graphen (Nullen aus vGuV entfernen --> nicht ausgeführte Trades)
for i in range(len(vGuV)):
    if vGuV[i] == 0:
        vGuV[i] = 'nan'


bShowFig == "true"

# Graphen anzeigen oder speichern
if (bSaveFig == "true" or bShowFig == "true"):
    # Histogramm R
    if bLong == "true":
        hist(vRLong, bins=50, range=(-5,5), normed=False, weights=None, cumulative=False,color='b', label='Long', alpha=0.5, log=False)
    if bShort == "true":
        hist(vRShort, bins=50, range=(-5,5), normed=False, weights=None, cumulative=False, color='r', label='Short', alpha=0.5, log=False)
    grid()
    title('Histogramm der Rentabilitaet in "R"  (blau=long  rot=short)')
    filename = "Histgramm_R.png"
    if bSaveFig == "true":
        savefig(filename,dpi=150)  
    elif bShowFig == "true":
        pyplot.show()
    else:
        clf() # clear figure
        close() # close a figure window
    
    # Histogramm k (Laufzeit in Tagen)
    if bLong == "true":
        hist(vKL, bins=5, range=(1,5), normed=False, weights=None, cumulative=False,color='b', label='Long', alpha=0.5, log=False)
    if bShort == "true":
        hist(vKS, bins=5, range=(1,5), normed=False, weights=None, cumulative=False,color='r', label='Long', alpha=0.5, log=False)
    title('Histogramm zur Tradedauer (blau=long  rot=short)')    
    filename = "Histgramm_Tradedauer.png"
    if bSaveFig == "true":
        savefig(filename,dpi=150)  
    elif bShowFig == "true":
        pyplot.show()
    else:
        clf() # clear figure
        close() # close a figure window
    
    # Plots
    alldays = DayLocator()
    months = MonthLocator()
    years = YearLocator()
    month_formatter = DateFormatter("%Y")
    
    fig = pyplot.figure()
    ax = fig.add_subplot(111)
    pyplot.plot(vR, 'b+')
    grid()
    title('Rentabilitaet der Trades in "R"')
    filename = "Summary_vR.png"
    
    if bSaveFig == "true":
        savefig(filename,dpi=150)  
    elif bShowFig == "true":
        pyplot.show()
    else:
        fig.clf() # clear figure
    
    
    fig = pyplot.figure()
    ax = fig.add_subplot(111)
    ax.xaxis.set_major_locator(years)
    ax.xaxis.set_minor_locator(months)
    ax.xaxis.set_major_formatter(month_formatter)
    pyplot.plot(vDate, vGuV, 'b+')
    fig.autofmt_xdate()
    grid()
    filename = "Summary_vGuV.png"
    title('Gewinn- und Verlust der Trades in Euro')
    if bSaveFig == "true":
        savefig(filename,dpi=150)  
    elif bShowFig == "true":
        pyplot.show()
    else:
        fig.clf() # clear figure
    
    
        
    
    fig = pyplot.figure()
    ax = fig.add_subplot(111)
    ax.xaxis.set_major_locator(years)
    ax.xaxis.set_minor_locator(months)
    ax.xaxis.set_major_formatter(month_formatter)
    pyplot.plot(vDate, vDepotValue)
    fig.autofmt_xdate()
    grid()
    filename = "Summary_vDepotValue.png"
    title('Entwicklung Depotvalue')
    if bSaveFig == "true":
        savefig(filename,dpi=150)  
    elif bShowFig == "true":
        pyplot.show()
    else:
        fig.clf() # clear figure


    
#Laufzeit
toc = time.clock()
print "Laufzeit: " + "%.2f" % (toc-tic) + " Sekunden"   