#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
Backtesting "Frei Schnauze"-System

ausgelagerte Utilities

"""
import numpy as np

   
def moving_average(x, n, type='simple'):
    """
    compute an n period moving average.

    type is 'simple' | 'exponential'

    """
    x = np.asarray(x)
    if type=='simple':
        weights = np.ones(n)
    else:
        weights = np.exp(np.linspace(-1., 0., n))

    weights /= weights.sum()


    a =  np.convolve(x, weights, mode='full')[:len(x)]
    a[:n] = a[n]
    return a
    
    
def remove_negatives(items):
    deletions = []
    k = 0    
    size = len(items)-1
    for k in range(size):
        if items[k] <= 0:
            deletions.append(k)

    items = np.delete(items, deletions, axis=0)
    return items       
     
     
def remove_positives(items):
    deletions = []
    k = 0    
    size = len(items)-1
    for k in range(size):
        if items[k] >= 0:
            deletions.append(k)

    items = np.delete(items, deletions, axis=0)
    return items  
      